package edu.umd.dawn.common.exceptions;

public class BaseExceptions {
    public static final DawnExceptionParameters METHOD_NOT_ALLOWED =
            new DawnExceptionParameters(405, "METHOD_NOT_ALLOWED", "method not allowed", "");
    public static final DawnExceptionParameters NOT_ACCEPTABLE =
            new DawnExceptionParameters(405, "NOT_ACCEPTABLE", "not acceptable", "");
    public static final DawnExceptionParameters UNSUPPORTED_MEDIA_TYPE =
            new DawnExceptionParameters(415, "UNSUPPORTED_MEDIA_TYPE", "unsupported media type", "");

    public static final DawnExceptionParameters BAD_REQUEST =
            new DawnExceptionParameters(400, "BAD_REQUEST", "Invalid request submitted", "");
            
    public static final DawnExceptionParameters INTERNAL_SERVER_ERROR =
            new DawnExceptionParameters(500, "INTERNAL_SERVER_ERROR", "Internal server error", "");
    public static final DawnExceptionParameters OUT_OF_BOUNDS =
            new DawnExceptionParameters(500, "INTERNAL_SERVER_ERROR", "Internal server error", "out of bounds");
    public static final DawnExceptionParameters UNHANDLED_INTERNAL_SERVER_ERROR =
            new DawnExceptionParameters(500, "INTERNAL_SERVER_ERROR", "Internal server error", "unhandled error");
  
    public static final DawnExceptionParameters SERVICE_UNAVAILABLE = 
            new DawnExceptionParameters(503, "SERVICE_UNAVAILABLE", "service unavailable", "");

    public static final DawnExceptionParameters FORBIDDEN =
            new DawnExceptionParameters(403, "FORBIDDEN", "user cannot access requested resource", "");
    public static final DawnExceptionParameters INVALID_JWT = new DawnExceptionParameters(
            401, "UNAUTHORIZED", "Invalid or empty JWT provided", "JWT provided is invalid");
    public static final DawnExceptionParameters NOT_FOUND =
            new DawnExceptionParameters(404, "NOT_FOUND", "Resource not found", "");

    public static DawnExceptionParameters INVALID_LIMIT(int limit) {
        return new DawnExceptionParameters(400, "BAD_REQUEST", String.format("limit of %d is invalid", limit), "");
    }

    public static DawnExceptionParameters INVALID_OFFSET(int offset) {
        return new DawnExceptionParameters(400, "BAD_REQUEST", String.format("offset of %d is invalid", offset), "");
    }
}
